// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.

using System.Collections.Generic;
using System.IO;

namespace System.Reflection.Emit
{
    public sealed class AssemblyBuilder : Assembly
    {
        internal AssemblyBuilder()
        {
            // Prevent generating a default constructor
        }

        public override string FullName
        {
            get
            {
                return default;
            }
        }

        public override bool IsDynamic
        {
            get
            {
                return default;
            }
        }

        public override Module ManifestModule
        {
            get
            {
                return default;
            }
        }

        public static AssemblyBuilder DefineDynamicAssembly(AssemblyName name, AssemblyBuilderAccess access)
        {
            ReflectionEmitThrower.ThrowPlatformNotSupportedException();
            return default;
        }

        public static AssemblyBuilder DefineDynamicAssembly(AssemblyName name, AssemblyBuilderAccess access, IEnumerable<CustomAttributeBuilder> assemblyAttributes)
        {
            ReflectionEmitThrower.ThrowPlatformNotSupportedException();
            return default;
        }

        public ModuleBuilder DefineDynamicModule(string name)
        {
            return default;
        }

        public override bool Equals(object obj)
        {
            return default;
        }

        public ModuleBuilder GetDynamicModule(string name)
        {
            return default;
        }

        public override int GetHashCode()
        {
            return default;
        }

        public override ManifestResourceInfo GetManifestResourceInfo(string resourceName)
        {
            return default;
        }

        public override string[] GetManifestResourceNames()
        {
            return default;
        }

        public override Stream GetManifestResourceStream(string name)
        {
            return default;
        }

        public void SetCustomAttribute(ConstructorInfo con, byte[] binaryAttribute)
        {
        }

        public void SetCustomAttribute(CustomAttributeBuilder customBuilder)
        {
        }
    }
}
